/** start date, could be Date instance, timestamp or date string */
export type DateTime = Date | number | string;
export type Options = {
    /**
     *  locale
     *  @default en_US
     * */
    locale?: string;
    /** custom local register function */
    localeRegister?: (number: number, index: number, totalSecoends?: number) => [string, string];
    /**
     *  update interval duration in milliseconds
     *  @default 1000
     * */
    interval?: number;
};
/** timeago string */
export type TimeAgo = string;
declare const useTimeAgo: (dateTime: DateTime, options?: Options) => TimeAgo;
export default useTimeAgo;
